#include <cstdio>
#include <cstdlib>
#include "pads.hh"

void bisqpads::padtype::write(BYTE value)
{
	if(value & 1) { pos = 0; randkey = rand() & 7; }
}

BYTE bisqpads::padtype::read()
{
	BYTE val = 0x40;
	switch(pos)
	{
		case 0 ... 7:
			if(pos == randkey)
			{
				val |= 1;
//				fprintf(stderr, "Pressing key %u at controller %u\n",
//					pos, signature);
			}
			break;
		case 17: val |= ((signature)&1); break;
		case 18: val |= ((signature>>1)&1); break;
		case 19: val |= ((signature>>2)&1); break;
		case 20: val |= ((signature>>3)&1); break;
	}
	++pos;
	return val;
}

bool bisqpads::write(const fWORD addr, fBYTE value)
{
	if(addr == 0x4016) { pad1.write(value); return true; }
	if(addr == 0x4017) { pad2.write(value); return true; }
	return false;
}
bool bisqpads::read(const fWORD addr, BYTE &value)
{
	if(addr == 0x4016) { value = pad1.read(); return true; }
	if(addr == 0x4017) { value = pad2.read(); return true; }
	return false;
}
